#include <gtk/gtk.h>
#include <string.h>

/* GUI setup helpers */
void add_label(GtkWidget *table, char *val, int row, int col)
{
	GtkWidget *label;
	
	label = gtk_label_new(val);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	
  gtk_table_attach(GTK_TABLE(table), label,
					col, col+1, row, row+1, GTK_FILL, GTK_FILL, 2, 2);
}

void add_entry(GtkWidget *window, GtkWidget *table, 
							int row, char *id, char *val)
{
	GtkWidget *entry;
	
	entry = gtk_entry_new();
 	gtk_entry_set_text(GTK_ENTRY(entry), val);
 	gtk_entry_set_editable(GTK_ENTRY(entry), TRUE);
	gtk_object_set_data(GTK_OBJECT(window), id, entry);
	
	gtk_table_attach(GTK_TABLE(table), entry, 
					1, 3, row, row+1,	GTK_FILL, GTK_FILL, 2, 2);
	
}

void xmess_destroy(GtkWidget *widget, gpointer data)
{
	gtk_object_destroy(GTK_OBJECT(data));
}

void xmess_end(GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}

/* lone is an ugly hack to handle startup errors before / without
 * the main interface starting */
void gtk_message_box(char *message, gboolean lone)
{
	GtkWidget *window;
	GtkWidget *button;
	GtkWidget *table;
	char buffer[32];
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);	
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	table = gtk_table_new(2, 1, TRUE);
	
	/* 28 char limit to keep things tidy */
	if(strlen(message) > 32)
	{
		strncpy(buffer, message, 28);
		strcat(buffer, "...");
	} else {
		strcpy(buffer, message);
	}
	
	add_label(table, buffer, 0, 0);

	button = gtk_button_new_with_label("  Ok  ");
	if(lone == TRUE)
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(xmess_end), window);
	else
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(xmess_destroy), window);
	gtk_table_attach(GTK_TABLE(table), button, 
					0, 1, 1, 2,	GTK_SHRINK, GTK_SHRINK, 2, 2);	
	
	gtk_widget_show_all(table);
	gtk_container_add (GTK_CONTAINER (window), table);
	
	gtk_widget_show(window);
	
	if(lone == TRUE)
		gtk_main();
}

